/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package perceptualcolorpicker;

import java.io.IOException;
import java.io.File;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.beans.InvalidationListener;

import javafx.scene.layout.AnchorPane;

import javafx.beans.Observable;
import javafx.embed.swing.SwingFXUtils;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.geometry.Pos;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Label;
import javafx.scene.image.WritableImage;
import javafx.scene.input.Clipboard;
import javafx.scene.input.ClipboardContent;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;

import javafx.scene.shape.Rectangle;
import javafx.stage.FileChooser;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javax.imageio.ImageIO;

/**
 *
 * @author olivier
 */
public class PerceptualColorPickerControl extends AnchorPane implements Initializable {

//x 10 000
    double minJ = 0;
    double maxJ = 175.80214189734804;
    double mina = -162.48471330964597;
    double maxa = 172.17445922948366;
    double minb = -249.5000648070522;
    double maxb = 208.0003033803981;
    final double minc = 0.0, maxc = 249.76987673046168;
    final double minh = 0.0, maxh = 360.0;
    ColorSpaceConvertion csc;

    /**
     *
     */
    public Label outilEnCours;

    /**
     *
     */
    public Label modeEnCours;

    /**
     *
     */
    public Label planEnCours;

    /**
     *
     */
    public Label codeEnCours;

    /**
     *
     */
    public Rectangle styleEnCours;

    /**
     *
     */
    public int diviSides;

    /**
     *
     */
    public WritableImage wi;

    /**
     *
     */
    public Droite droite = null;

    /**
     *
     */
    public Quadratique quadratic = null;

    /**
     *
     */
    public ORectangle orectangle = null;

    /**
     *
     */
    public Polygone polygone = null;

    /**
     *
     */
    public Palette palette = null;

    /**
     *
     */
    public Color c;

    /**
     *
     */
    public int value = 50;

    /**
     *
     */
    public String[] codes;

    /**
     *
     */
    public String darkStyleUrl = getClass().getResource("darkstyle.css").toExternalForm();

    /**
     *
     */
    public String lightStyleUrl = getClass().getResource("lightstyle.css").toExternalForm();

    /**
     *
     */
    @FXML
    public Label mSegment;

    /**
     *
     */
    @FXML
    public Label mQuadratic;

    /**
     *
     */
    @FXML
    public Label mRectangle;

    /**
     *
     */
    @FXML
    public Label mPolygon;

    /**
     *
     */
    @FXML
    public Circle curseurO;

    /**
     *
     */
    @FXML
    public Label ma_b;

    /**
     *
     */
    @FXML
    public Label ma_L;

    /**
     *
     */
    @FXML
    public Label mb_L;

    /**
     *
     */
    @FXML
    public Label mc_H;

    /**
     *
     */
    @FXML
    public Label mc_L;

    /**
     *
     */
    @FXML
    public Label mH_L;

    /**
     *
     */
    @FXML
    public Label mOrtho;

    /**
     *
     */
    @FXML
    public Label mContraste;

    /**
     *
     */
    @FXML
    public Label mCenter;

    /**
     *
     */
    @FXML
    public Label mRgb;

    /**
     *
     */
    @FXML
    public Label mLab;

    /**
     *
     */
    @FXML
    public Label mLch;

    /**
     *
     */
    @FXML
    public Label mWeb;

    /**
     *
     */
    @FXML
    public Label labelOrtho;

    /**
     *
     */
    @FXML
    public Label mPlusDivision;

    /**
     *
     */
    @FXML
    public Label mMoinsDivision;

    /**
     *
     */
    @FXML
    public Label labelDivision;

    /**
     *
     */
    @FXML
    public Circle curseurC;

    /**
     *
     */
    @FXML
    public Canvas canvas;

    /**
     *
     */
    @FXML
    public Circle gradient;

    /**
     *
     */
    @FXML
    public Pane paneCanvas;

    /**
     *
     */
    @FXML
    public HBox hboxPalette;

    /**
     *
     */
    @FXML
    public HBox hboxCodes;

    /**
     *
     */
    @FXML
    public Label mHelp;

    /**
     *
     */
    @FXML
    public Label mSnapshot;
    //@FXML
    //public AnchorPane this;

    /**
     *
     */
    @FXML
    public VBox vboxSnapshot;

    /**
     *
     */
    @FXML
    public Label labelSnapshot;

    /**
     *
     */
    @FXML
    public Rectangle buttonDark;

    /**
     *
     */
    @FXML
    public Rectangle buttonLight;

    /**
     *
     */
    @FXML
    public Label mPalette;

    /**
     *
     */
    @FXML
    public Label mCopy;

    /**
     *
     */
    @FXML
    public Label mSNAPSHOT;

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // this.getScene().getStylesheets().add(darkStyleUrl);
        csc = new ColorSpaceConvertion();
        outilEnCours = mSegment;
        mSegment.setStyle("-fx-text-fill: #fff;");
        modeEnCours = mOrtho;
        mOrtho.setStyle("-fx-text-fill: #fff;");
        planEnCours = ma_b;
        ma_b.setStyle("-fx-text-fill: #fff;");
        codeEnCours = mLab;
        mLab.setStyle("-fx-text-fill: #fff;");
        labelSnapshot.setText("Jzazbz");
        diviSides = 5;
        labelDivision.setText(String.valueOf(diviSides));
        styleEnCours = buttonDark;
        creationOutils();
        choixOutils();
        dessinOrtho(maxJ/2.0);

    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuOutilsClicked(MouseEvent event) {
        paneCanvas.getChildren().clear();//le parent des outils est le paneCanvas 

        mSegment.setStyle("-fx-text-fill: #888;");
        mQuadratic.setStyle("-fx-text-fill: #888;");
        mRectangle.setStyle("-fx-text-fill: #888;");
        mPalette.setStyle("-fx-text-fill: #888;");
        mPolygon.setStyle("-fx-text-fill: #888;");

        Label l = (Label) event.getSource();
        l.setStyle("-fx-text-fill: #fff;");
        outilEnCours = l;

        choixOutils();
        majCouleurs();
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuPlansClicked(MouseEvent event) {
        ma_b.setStyle("-fx-text-fill: #888;");
        ma_L.setStyle("-fx-text-fill: #888;");
        mb_L.setStyle("-fx-text-fill: #888;");
        mc_H.setStyle("-fx-text-fill: #888;");
        mc_L.setStyle("-fx-text-fill: #888;");
        mH_L.setStyle("-fx-text-fill: #888;");
        Label l = (Label) event.getSource();
        l.setStyle("-fx-text-fill: #fff;");
        planEnCours = l;
        if (l == ma_b) {
            labelOrtho.setText("Jz");
        }
        if (l == ma_L) {
            labelOrtho.setText("bz");
        }
        if (l == mb_L) {
            labelOrtho.setText("az");
        }
        if (l == mc_H) {
            labelOrtho.setText("Jz");
        }
        if (l == mc_L) {
            labelOrtho.setText("hz");
        }
        if (l == mH_L) {
            labelOrtho.setText("Cz");
        }

        if (modeEnCours == mOrtho) {
            dessinOrtho(value);
        } else {
            dessinContraste(value);
        }
        majCouleurs();
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuModesClicked(MouseEvent event) {
        mOrtho.setStyle("-fx-text-fill: #888;");
        mContraste.setStyle("-fx-text-fill: #888;");
        Label l = (Label) event.getSource();
        l.setStyle("-fx-text-fill: #fff;");
        modeEnCours = l;
        if (l == mOrtho) {
            curseurO.setCenterX(810);
            dessinOrtho(50);
        } else {
            curseurC.setCenterX(810);
            dessinContraste(180);
        }
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuCenterClicked(MouseEvent event) {
        if (outilEnCours == mPolygon) {
            polygone.center.setCenterX(215);
            polygone.center.setCenterY(215);
        }
        if (outilEnCours == mPalette) {
            palette.center.setCenterX(215);
            palette.center.setCenterY(215);
        }
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuColorCodeClicked(MouseEvent event) {
        mRgb.setStyle("-fx-text-fill: #888;");
        mLab.setStyle("-fx-text-fill: #888;");
        mLch.setStyle("-fx-text-fill: #888;");
        mWeb.setStyle("-fx-text-fill: #888;");
        Label l = (Label) event.getSource();
        l.setStyle("-fx-text-fill: #fff;");
        codeEnCours = l;
        labelSnapshot.setText(l.getText());
        majCodes();
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuDivisionClicked(MouseEvent event) {
        Label l = (Label) event.getSource();
        if (l == mPlusDivision && diviSides < 7) {
            diviSides++;
        } else if (l == mMoinsDivision && diviSides > 3) {
            diviSides--;
        }
        labelDivision.setText(String.valueOf(diviSides));
        //changer les outils et maj
        paneCanvas.getChildren().clear();//le parent des outils est le paneCanvas 
        creationOutils();
        choixOutils();
        majCouleurs();

    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuHelpClicked(MouseEvent event) {
        Stage dialogStage = new Stage();
        Parent root = null;
        try {
            root = FXMLLoader.load(getClass().getResource("/perceptualcolorpicker/help/help.fxml"));
        } catch (IOException ex) {
            Logger.getLogger(PerceptualColorPickerControl.class.getName()).log(Level.SEVERE, null, ex);
        }

        Scene scene = new Scene(root);
        dialogStage.initModality(Modality.NONE);
        dialogStage.setScene(scene);
        dialogStage.setTitle("PerceptualClorPicker help");
        dialogStage.show();
    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuSnapshotClicked(MouseEvent event) {
        WritableImage snapshot;
        if (event.getSource().equals(mSNAPSHOT)) {
            snapshot = this.snapshot(null, null);
        } else {
            snapshot = vboxSnapshot.snapshot(null, null);
        }
        FileChooser fileChooser = new FileChooser();
        fileChooser.setTitle("Save the snapshot as...");
        String timeStamp = new SimpleDateFormat("yyyy.MM.dd.HH.mm.ss").format(new Date());
        fileChooser.setInitialFileName(timeStamp + ".png");
        ArrayList<String> ext = new ArrayList<String>();
        ext.add(".png");
        fileChooser.setSelectedExtensionFilter(new FileChooser.ExtensionFilter("Snapshot", ext));
        File file = fileChooser.showSaveDialog(this.getScene().getWindow());
        if (file != null) {
            try {
                ImageIO.write(SwingFXUtils.fromFXImage(snapshot, null), "png", file);
            } catch (IOException e) {
                Alert alert = new Alert(AlertType.ERROR);
                alert.setTitle("Error Dialog");
                alert.setHeaderText("IOException");
                alert.setContentText(e.getLocalizedMessage());
                alert.showAndWait();
            }
        }

    }

    /**
     *
     * @param event
     */
    @FXML
    public void menuCopyClicked(MouseEvent event) {
        Clipboard clipboard = Clipboard.getSystemClipboard();
        final ClipboardContent content = new ClipboardContent();
        String s = "// ";
        for (int i = 0; i < codes.length; i++) {
            s = s + codes[i] + " ";
        }
        content.putString(s);
        clipboard.setContent(content);
    }

    /**
     *
     * @param event
     */
    @FXML
    public void curseurOMouseDragged(MouseEvent event) {
        if (modeEnCours == mOrtho) {
            curseurO.setCenterX(event.getX());//Xpos initiale = 810 L = 140
            if (curseurO.getCenterX() < 740) {
                curseurO.setCenterX(740);
            }
            if (curseurO.getCenterX() > 880) {
                curseurO.setCenterX(880);
            }
            value = 0;
            double k = (curseurO.getCenterX() - 740) / (880 - 740);
            if (planEnCours == ma_b) {
                value = (int) Math.round(minJ + (maxJ - minJ) * k);
            }
            if (planEnCours == ma_L) {
                value = (int) Math.round(minb + (maxb - minb) * k);
            }
            if (planEnCours == mb_L) {
                value = (int) Math.round(mina + (maxa - mina) * k);
            }
            if (planEnCours == mc_H) {
                value = (int) Math.round(minJ + (maxJ - minJ) * k);
            }
            if (planEnCours == mc_L) {
                value = (int) Math.round(minh + (maxh - minh) * k);
            }
            if (planEnCours == mH_L) {
                value = (int) Math.round(minc + (maxc - minc) * k);
            }
            dessinOrtho(value);
        }
    }

    /**
     *
     * @param event
     */
    @FXML
    public void curseurCMouseDragged(MouseEvent event) {
        if (modeEnCours == mContraste) {
            curseurC.setCenterX(event.getX());//Xpos initiale = 810 L = 140
            if (curseurC.getCenterX() < 740) {
                curseurC.setCenterX(740);
            }
            if (curseurC.getCenterX() > 880) {
                curseurC.setCenterX(880);
            }
            value = 0;
            double k = (curseurC.getCenterX() - 740) / (880 - 740);
            value = (int) Math.round(360 * k);
            dessinContraste(value);
            gradient.setRotate(-value);
        }
    }

    /**
     *
     * @param event
     */
    @FXML
    public void styleButtonClicked(MouseEvent event) {
        Rectangle rect = (Rectangle) event.getSource();
        if (rect == buttonDark) {
            this.getScene().getStylesheets().remove(lightStyleUrl);
            if (!this.getScene().getStylesheets().contains(darkStyleUrl)) {
                this.getScene().getStylesheets().add(darkStyleUrl);
            }
            styleEnCours = buttonDark;
        }
        if (rect == buttonLight) {
            this.getScene().getStylesheets().remove(darkStyleUrl);
            if (!this.getScene().getStylesheets().contains(lightStyleUrl)) {
                this.getScene().getStylesheets().add(lightStyleUrl);
            }
            styleEnCours = buttonLight;
        }
        if (modeEnCours == mOrtho) {
            dessinOrtho(value);
        } else {
            dessinContraste(value);
        }

    }

    /**
     *
     */
    public PerceptualColorPickerControl() {
        FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("PerceptualColorPicker.fxml"));
        fxmlLoader.setRoot(this);
        fxmlLoader.setController(this);

        try {
            fxmlLoader.load();
        } catch (IOException exception) {
            throw new RuntimeException(exception);
        }

    }

    /**
     *
     * @param _value
     */
    public void dessinOrtho(double _value) {
        GraphicsContext gc = canvas.getGraphicsContext2D();
        if (styleEnCours == buttonLight) {
            gc.setFill(Color.web("#bbb"));
        } else {
            gc.setFill(Color.web("#444"));
        }
        gc.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
        final int pas = 1;
        double[] jab = new double[3];
        double[] jch = new double[3];
        if (planEnCours == ma_b) {
            jab[0] = _value / 10000.0;
            for (double a = mina; a < maxa; a += pas) {
                for (double b = minb; b < maxb; b += pas) {
                    jab[1] = a / 10000.0;
                    jab[2] = b / 10000.0;
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == ma_L) {
            jab[2] = _value / 10000.0;
            for (double a = mina; a < maxa; a += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jab[1] = a / 10000.0;
                    jab[0] = L / 10000.0;
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == mb_L) {
            jab[1] = _value / 10000.0;
            for (double b = minb; b < maxb; b += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jab[2] = b / 10000.0;
                    jab[0] = L / 10000.0;
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == mc_H) {
            jch[0] = _value/10000.0;
            for (double c = minc; c < maxc; c += pas) {
                for (double H = minh; H < maxh; H += pas) {
                    jch[1] = c/10000.0;
                    jch[2] = H;
                    dessinJch(jch);
                }
            }
        }
        if (planEnCours == mc_L) {
            jch[2] = _value;
            for (double c = minc; c < maxc; c += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jch[1] = c/10000.0;
                    jch[0] = L/10000.0;
                    dessinJch(jch);
                }
            }
        }
        if (planEnCours == mH_L) {
            jch[1] = _value/10000.0;
            for (double H = minh; H < maxh; H += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jch[2] = H;
                    jch[0] = L/10000.0;
                    dessinJch(jch);
                }
            }
        }
        wi = canvas.snapshot(null, null);
        majCouleurs();
    }

    /**
     *
     * @param _value
     */
    public void dessinContraste(double _value) {
        GraphicsContext gc = canvas.getGraphicsContext2D();
        if (styleEnCours == buttonLight) {
            gc.setFill(Color.web("#bbb"));
        } else {
            gc.setFill(Color.web("#444"));
        }
        gc.fillRect(0, 0, canvas.getWidth(), canvas.getHeight());
        final int pas = 1;
        double[] jab = new double[3];
        double[] jch = new double[3];
        if (planEnCours == ma_b) {
            for (double a = mina; a < maxa; a += pas) {
                for (double b = minb; b < maxb; b += pas) {
                    jab[1] = a / 10000.0;
                    jab[2] = b / 10000.0;
                    jab[0] = (double) ((((Math.cos(_value * Math.PI / 180) * a + Math.sin(_value * Math.PI / 180) * b) / 2) + 50) / 10000.0);
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == ma_L) {
            for (double a = mina; a < maxa; a += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jab[1] = a / 10000.0;
                    jab[0] = L / 10000.0;
                    jab[2] = (double) ((Math.cos(_value * Math.PI / 180) * L + Math.sin(_value * Math.PI / 180) * a) / 10000.0);
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == mb_L) {
            for (double b = minb; b < maxb; b += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jab[2] = b / 10000.0;
                    jab[0] = L / 10000.0;
                    jab[1] = (double) ((Math.cos(_value * Math.PI / 180) * L + Math.sin(_value * Math.PI / 180) * b) )/ 10000.0;
                    dessinJab(jab);
                }
            }
        }
        if (planEnCours == mc_H) {
            for (double c = minc; c < maxc; c += pas) {
                for (double H = minh; H < maxh; H += pas) {
                    jch[1] = c/10000.0;
                    jch[2] = H;
                    jch[0] = (double) (((Math.cos(_value * Math.PI / 180) * c + Math.sin(_value * Math.PI / 180) * H) / 2) + 50)/10000.0;
                    dessinJch(jch);
                }
            }
        }
        if (planEnCours == mc_L) {
            for (double c = minc; c < maxc; c += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jch[1] = c/10000.0;
                    jch[0] = L/10000.0;
                    jch[2] = (double) (((Math.cos(_value * Math.PI / 180) * L + Math.sin(_value * Math.PI / 180) * c)));
                    dessinJch(jch);
                }
            }
        }
        if (planEnCours == mH_L) {
            for (double H = minh; H < maxh; H += pas) {
                for (double L = minJ; L < maxJ; L += pas) {
                    jch[2] = H;
                    jch[0] = L/10000.0;
                    jch[1] = (double) (((Math.cos(_value * Math.PI / 180) * L + Math.sin(_value * Math.PI / 180) * H)))/10000.0;
                    dessinJch(jch);
                }
            }
        }
        wi = canvas.snapshot(null, null);
        majCouleurs();
    }

    /**
     *
     * @param _jab
     */
    public void dessinJab(double[] _jab) {
        GraphicsContext gc = canvas.getGraphicsContext2D();
        double[] rgb = new double[3];
        double[] xyz = new double[3];
        csc.JabToXYZ(_jab, xyz);
        csc.XYZToRGB(xyz, rgb);
        if ((rgb[0] <= 255) && (rgb[0] >= 0)) {
            if ((rgb[1] <= 255) && (rgb[1] >= 0)) {
                if ((rgb[2] <= 255) && (rgb[2] >= 0)) {
                    int x = 0;
                    int y = 0;
                    if (planEnCours == ma_b) {
                        x = (int) (215 + _jab[1] * 10000 * 215/-minb);
                        y = (int) (215 + _jab[2] * 10000 * 215 / -minb);
                    }
                    if (planEnCours == ma_L) {
                        x = (int) (215 + _jab[1] * 10000 *215/maxJ);
                        y = (int) (0 + _jab[0] * 10000 *215/maxJ);
                    }
                    if (planEnCours == mb_L) {
                        x = (int) (215 + _jab[2] * 10000 * 215/-minb );
                        y = (int) (0 + _jab[0] * 10000 * 215/-minb );
                    }
                    gc.setFill(Color.rgb((int) rgb[0], (int) rgb[1], (int) rgb[2]));
                    gc.fillRect(x, 430 - y, 3, 3);
                }
            }
        }
    }

    /**
     *
     * @param _jch
     */
    public void dessinJch(double[] _jch) {
        GraphicsContext gc = canvas.getGraphicsContext2D();
        double[] jab = new double[3];
        double[] rgb = new double[3];
        double[] xyz = new double[3];
        csc.JCHToJab(_jch, jab);
        csc.JabToXYZ(jab, xyz);
        csc.XYZToRGB(xyz, rgb);
        if ((rgb[0] <= 255) && (rgb[0] >= 0)) {
            if ((rgb[1] <= 255) && (rgb[1] >= 0)) {
                if ((rgb[2] <= 255) && (rgb[2] >= 0)) {
                    int x = 0;
                    int y = 0;
                    if (planEnCours == mc_H) {
                        x = (int) (0 + _jch[2] * 430 / 360);
                        y = (int) (0 + _jch[1] * 10000 * 430 / 360);
                    }
                    if (planEnCours == mc_L) {
                        x = (int) (0 + _jch[1] * 10000 * 430/(maxc));
                        y = (int) (0 + _jch[0] * 10000 * 430/(maxc));
                    }
                    if (planEnCours == mH_L) {
                        x = (int) (0 + _jch[2] * 430 / 360);
                        y = (int) (0 + _jch[0] * 10000 * 430 / 360);
                    }
                    gc.setFill(Color.rgb((int) rgb[0], (int) rgb[1], (int) rgb[2]));
                    gc.fillRect(x, 430 - y, 3, 3);
                }
            }
        }
    }

    /**
     *
     */
    public void majCouleurs() {

        hboxPalette.getChildren().clear();
        Rectangle r;
        double h = hboxPalette.getPrefHeight();
        double l = (hboxPalette.getPrefWidth() - (diviSides - 1) * 5) / diviSides;

        if (outilEnCours == mSegment) {
            c = wi.getPixelReader().getColor((int) droite.ligne.getStartX(), (int) droite.ligne.getStartY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            for (int i = 0; i < droite.circleCarets.length; i++) {
                c = wi.getPixelReader().getColor((int) droite.circleCarets[i].getCenterX(), (int) droite.circleCarets[i].getCenterY());
                r = new Rectangle(l, h);
                r.setArcHeight(10);
                r.setArcWidth(10);
                if (c != null) {
                    r.setFill(c);
                }
                hboxPalette.getChildren().add(r);
            }
            c = wi.getPixelReader().getColor((int) droite.ligne.getEndX(), (int) droite.ligne.getEndY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
        }

        if (outilEnCours == mQuadratic) {
            c = wi.getPixelReader().getColor((int) quadratic.q.getStartX(), (int) quadratic.q.getStartY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            for (int i = 0; i < quadratic.circleCarets.length; i++) {
                c = wi.getPixelReader().getColor((int) quadratic.circleCarets[i].getCenterX(), (int) quadratic.circleCarets[i].getCenterY());
                r = new Rectangle(l, h);
                r.setArcHeight(10);
                r.setArcWidth(10);
                if (c != null) {
                    r.setFill(c);
                }
                hboxPalette.getChildren().add(r);
            }

            c = wi.getPixelReader().getColor((int) quadratic.q.getEndX(), (int) quadratic.q.getEndY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
        }

        if (outilEnCours == mRectangle) {
            c = wi.getPixelReader().getColor((int) orectangle.ligne.getStartX(), (int) orectangle.ligne.getStartY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            for (int i = 0; i < orectangle.circleCarets.length; i++) {
                c = wi.getPixelReader().getColor((int) orectangle.circleCarets[i].getCenterX(), (int) orectangle.circleCarets[i].getCenterY());
                r = new Rectangle(l, h);
                r.setArcHeight(10);
                r.setArcWidth(10);
                if (c != null) {
                    r.setFill(c);
                }
                hboxPalette.getChildren().add(r);
            }
            c = wi.getPixelReader().getColor((int) orectangle.ligne.getEndX(), (int) orectangle.ligne.getEndY());
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
        }

        if (outilEnCours == mPolygon) {
            c = wi.getPixelReader().getColor((int) Math.round(polygone.peri.getCenterX()), (int) Math.round(polygone.peri.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            for (int i = 1; i < polygone.nbSides; i++) {
                int X = (int) Math.round(polygone.circleSommets[i].getCenterX());
                int Y = (int) Math.round(polygone.circleSommets[i].getCenterY());
                c = wi.getPixelReader().getColor(X, Y);
                r = new Rectangle(l, h);
                r.setArcHeight(10);
                r.setArcWidth(10);
                if (c != null) {
                    r.setFill(c);
                }
                hboxPalette.getChildren().add(r);
            }
        }

        if (outilEnCours == mPalette) {
            c = wi.getPixelReader().getColor((int) Math.round(palette.peri1.getCenterX()), (int) Math.round(palette.peri1.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.peri2.getCenterX()), (int) Math.round(palette.peri2.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.peri3.getCenterX()), (int) Math.round(palette.peri3.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.c0.getCenterX()), (int) Math.round(palette.c0.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.c1.getCenterX()), (int) Math.round(palette.c1.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.c2.getCenterX()), (int) Math.round(palette.c2.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);
            c = wi.getPixelReader().getColor((int) Math.round(palette.c3.getCenterX()), (int) Math.round(palette.c3.getCenterY()));
            r = new Rectangle(l, h);
            r.setArcHeight(10);
            r.setArcWidth(10);
            if (c != null) {
                r.setFill(c);
            }
            hboxPalette.getChildren().add(r);

        }
        majCodes();
    }

    /**
     *
     */
    public void majCodes() {
        hboxCodes.getChildren().clear();
        double h = hboxCodes.getPrefHeight();
        double l = (hboxPalette.getPrefWidth() - (diviSides - 1) * 5) / diviSides;
        codes = new String[hboxPalette.getChildren().size()];

        for (int i = 0; i < hboxPalette.getChildren().size(); i++) {
            Rectangle rect = (Rectangle) hboxPalette.getChildren().get(i);
            Color c = (Color) rect.getFill();
            codes[i] = "#" + c.toString().substring(2, 8);
            Label l0 = new Label();
            Label l1 = new Label();
            Label l2 = new Label();
            l0.setStyle("-fx-font-size: 12;");
            l1.setStyle("-fx-font-size: 12;");
            l2.setStyle("-fx-font-size: 12;");
            l0.setPrefWidth(l);
            l1.setPrefWidth(l);
            l2.setPrefWidth(l);
            l0.setMinWidth(l);
            l1.setMinWidth(l);
            l2.setMinWidth(l);
            l0.setMaxWidth(l);
            l1.setMaxWidth(l);
            l2.setMaxWidth(l);
            l0.setAlignment(Pos.CENTER);
            l1.setAlignment(Pos.CENTER);
            l2.setAlignment(Pos.CENTER);
            if (!(c.equals(Color.rgb(68, 68, 68)) || c.equals(Color.rgb(187, 187, 187)))) {

                if (codeEnCours == mRgb) {
                    l0.setText(String.valueOf((int) Math.round(c.getRed() * 255)));
                    l1.setText(String.valueOf((int) Math.round(c.getGreen() * 255)));
                    l2.setText(String.valueOf((int) Math.round(c.getBlue() * 255)));
                }
                if (codeEnCours == mLab) {
                    double[] jab = csc.colorToJab(c);
                    l0.setText(String.valueOf((int) Math.round(jab[0]*10000)));
                    l1.setText(String.valueOf((int) Math.round(jab[1]*10000)));
                    l2.setText(String.valueOf((int) Math.round(jab[2]*10000)));
                }
                if (codeEnCours == mLch) {
                    double[] jch = csc.colorToJch(c);
                    l0.setText(String.valueOf((int) Math.round(jch[0]*10000)));
                    l1.setText(String.valueOf((int) Math.round(jch[1]*10000)));
                    l2.setText(String.valueOf((int) Math.round(jch[2])));
                }
                if (codeEnCours == mWeb) {
                    double[] jch = csc.colorToJch(c);
                    l0.setText(c.toString().substring(2, 8));
                    l1.setText("");
                    l2.setText("");
                }
            } else {

            }
            VBox vbox = new VBox();
            vbox.setPrefSize(h, l);
            vbox.setAlignment(Pos.CENTER);
            vbox.getChildren().addAll(l0, l1, l2);
            hboxCodes.getChildren().add(vbox);
        }

    }

    /**
     *
     */
    public void creationOutils() {

        InvalidationListener il = (Observable o) -> {
            majCouleurs();
        };
        droite = new Droite(175, 215, 315, 215, diviSides);
        droite.ligne.setId("segment");
        droite.thumb1.centerXProperty().addListener(il);
        droite.thumb1.centerYProperty().addListener(il);
        droite.thumb2.centerXProperty().addListener(il);
        droite.thumb2.centerYProperty().addListener(il);

        quadratic = new Quadratique(175, 215, 215, 175, 315, 215, diviSides);
        quadratic.thumb1.centerXProperty().addListener(il);
        quadratic.thumb1.centerYProperty().addListener(il);
        quadratic.thumb2.centerXProperty().addListener(il);
        quadratic.thumb2.centerYProperty().addListener(il);
        quadratic.thumb3.centerXProperty().addListener(il);
        quadratic.thumb3.centerYProperty().addListener(il);

        orectangle = new ORectangle(215, 215, 315, 275);
        orectangle.thumb1.centerXProperty().addListener(il);
        orectangle.thumb1.centerYProperty().addListener(il);
        orectangle.thumb2.centerXProperty().addListener(il);
        orectangle.thumb2.centerYProperty().addListener(il);
        //orectangle.thumb1.layoutXProperty().addListener(il);

        polygone = new Polygone(215, 215, 275, 215, diviSides);
        polygone.center.centerXProperty().addListener(il);
        polygone.center.centerYProperty().addListener(il);
        polygone.peri.centerXProperty().addListener(il);
        polygone.peri.centerYProperty().addListener(il);

        //palette = new Palette(260, 226, 178, 204, 310, 157, 290, 318);
        palette = new Palette(215, 215, 143, 193, 275, 146, 224, 306);
        palette.center.centerXProperty().addListener(il);
        palette.center.centerYProperty().addListener(il);
        palette.peri1.centerXProperty().addListener(il);
        palette.peri1.centerYProperty().addListener(il);
        palette.peri2.centerXProperty().addListener(il);
        palette.peri2.centerYProperty().addListener(il);
        palette.peri3.centerXProperty().addListener(il);
        palette.peri3.centerYProperty().addListener(il);

        curseurO.centerXProperty().addListener(il);
        curseurC.centerXProperty().addListener(il);
    }

    /**
     *
     */
    public void choixOutils() {
        if (outilEnCours == mSegment) {
            diviSides = Integer.valueOf(labelDivision.getText());
            paneCanvas.getChildren().add(droite);
            mCenter.setId(null);
        }
        if (outilEnCours == mQuadratic) {
            diviSides = Integer.valueOf(labelDivision.getText());
            paneCanvas.getChildren().add(quadratic);
            mCenter.setId(null);
        }
        if (outilEnCours == mRectangle) {
            diviSides = 4;
            paneCanvas.getChildren().add(orectangle);
            mCenter.setId(null);
        }
        if (outilEnCours == mPolygon) {
            diviSides = Integer.valueOf(labelDivision.getText());
            paneCanvas.getChildren().add(polygone);
            mCenter.setId("centerable");
        }
        if (outilEnCours == mPalette) {
            diviSides = 7;
            paneCanvas.getChildren().add(palette);
            mCenter.setId("centerable");
        }
    }

}
